CREATE TABLE HCL 
    ( 
     HCL_ID bigint  NOT NULL 
    )  
;



ALTER TABLE HCL 
    ADD CONSTRAINT HCL_PK PRIMARY KEY ( HCL_ID ) 
;



CREATE TABLE HCL_CODE 
    ( 
     HCODE_ID bigint  NOT NULL , 
     PARENT_HCODE_ID bigint , 
     LCD_ID bigint  NOT NULL , 
     H_ID bigint  NOT NULL , 
     LEVEL_ID bigint NULL
    )  
;



ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_PK PRIMARY KEY ( HCODE_ID ) 
;



CREATE TABLE HIERARCHY 
    ( 
     H_ID bigint  NOT NULL , 
     HCL_ID bigint  NOT NULL 
    )  
;



ALTER TABLE HIERARCHY 
    ADD CONSTRAINT HIERARCHY_PK PRIMARY KEY ( H_ID )
;



CREATE TABLE [HLEVEL] 
    ( 
     LEVEL_ID bigint  NOT NULL , 
     H_ID bigint  NOT NULL , 
     PARENT_LEVEL_ID bigint NULL
    )  
;



ALTER TABLE [HLEVEL]
    ADD CONSTRAINT LEVEL_PK PRIMARY KEY ( LEVEL_ID ) 
;




ALTER TABLE HCL 
    ADD CONSTRAINT HCL_ARTEFACT_FK FOREIGN KEY 
    ( 
     HCL_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
    ON DELETE CASCADE 
    
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_ARTEFACT_FK FOREIGN KEY 
    ( 
     HCODE_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
    
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_DSD_CODE_FK FOREIGN KEY 
    ( 
     LCD_ID
    ) 
    REFERENCES DSD_CODE 
    ( 
     LCD_ID
    ) 
    
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_HCL_CODE_FK FOREIGN KEY 
    ( 
     PARENT_HCODE_ID
    ) 
    REFERENCES HCL_CODE 
    ( 
     HCODE_ID
    ) 
    
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_HIERARCHY_FK FOREIGN KEY 
    ( 
     H_ID
    ) 
    REFERENCES HIERARCHY 
    ( 
     H_ID
    ) 
    ON DELETE CASCADE 
    
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_LEVEL_FK FOREIGN KEY 
    ( 
     LEVEL_ID
    ) 
    REFERENCES [HLEVEL] 
    ( 
     LEVEL_ID
    ) 
    
;


ALTER TABLE HIERARCHY 
    ADD CONSTRAINT HIERARCHY_ARTEFACT_FK FOREIGN KEY 
    ( 
     H_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
    
;


ALTER TABLE HIERARCHY 
    ADD CONSTRAINT HIERARCHY_HCL_FK FOREIGN KEY 
    ( 
     HCL_ID
    ) 
    REFERENCES HCL 
    ( 
     HCL_ID
    ) 
    ON DELETE CASCADE 
    
;


ALTER TABLE [HLEVEL] 
    ADD CONSTRAINT LEVEL_ARTEFACT_FK FOREIGN KEY 
    ( 
     LEVEL_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
    
;


ALTER TABLE [HLEVEL] 
    ADD CONSTRAINT LEVEL_HIERARCHY_FK FOREIGN KEY 
    ( 
     H_ID
    ) 
    REFERENCES HIERARCHY 
    ( 
     H_ID
    ) 
    ON DELETE CASCADE 
    
;


ALTER TABLE [HLEVEL] 
    ADD CONSTRAINT LEVEL_LEVEL_FK FOREIGN KEY 
    ( 
     PARENT_LEVEL_ID
    ) 
    REFERENCES [HLEVEL] 
    ( 
     LEVEL_ID
    ) 
    
;

ALTER TABLE ARTEFACT ADD VALID_FROM varchar(50) NULL
;

ALTER TABLE ARTEFACT ADD VALID_TO varchar(50) NULL
;

update DB_VERSION SET VERSION = '2.5'
;

ALTER TABLE ARTEFACT ALTER COLUMN ID varchar(50) NULL
;

ALTER TABLE ARTEFACT ALTER COLUMN AGENCY varchar(50) NULL
;
